//********************************************************************
// transforme les fichiers .CUT de CNC en un fichier de commandes :
//
//   D dure dcimale   <=== indique un dlai en nb d'IT timers
//   C commande dcimal <=== valeur de la commande  envoyer sur le port //
//
// les commandes sont envoyes avec les dlais suivants :
//    T0 = 1 er ordre bits de direction
//    t1 = 2 ime ordre bits de direction et de commande
//    t2 = mise  zro des bits de commande
// avec :
//     t1 = T0 + epsilon
//     t2 = T0 + 1/2 IT timer
//
//*********************************************************************

#include <conio.h>
#include <stdio.h>


#include <math.h>
#include <string.h>




void main (int argc,char *argv[])
{

	int count;

	/* for (count=0;count < argc;count++) {
		printf(
			"Argument %d = %s\n",
			count,
			argv[count]);
	} */




	char chaine[100], tampon[200];
	long i;
	int j;
	int k, c, duree, sens;
	int Bits;    /* 0 <= Bits <= 255 */
	int Dummy;
	unsigned char commande,value,par1, par2, par3, par4;

	FILE *sortie ;
	FILE *cut;
	FILE *tempo;


	cut = fopen(argv[1],"r");
	if (cut == NULL) {
		printf("\n\n\nERREUR : le fichier %s n'existe pas ...\n\n\n\n",argv[1]);
		goto sortie;
	}

	sortie = fopen( "sortie.txt", "w");

	//filtre des commentaires
	c = fgetc(cut);
	while (c != EOF) {
		if ((c == 'T') | (c == '/') | (c == 'F') | (c == 'N') | (c == 'H'))
		{
			do {
				c = fgetc(cut);
			}
			while (c != '\n');

		}
		else
		    {
			fputc (c, sortie);
		}
		c = fgetc(cut);
	}
	fclose (sortie);


	// generation des ordres CNC pour port par

	tempo = fopen("tempo.txt","w");
	sortie = fopen( "sortie.txt", "r");


	c = fgetc(sortie);
	do {
		ungetc (c,sortie);
		k= fscanf( sortie, "%d" , &duree); // duree de la tempo
		fprintf(tempo,"D %d\n",duree);
		c = fgetc(sortie);
		commande = 0;
		while ((c != 10) && (c != EOF)) {
			if (c == 32) c = fgetc(sortie); // on saute les blancs
			switch (c) { // interprtation des dplacements



			case 43: // +



				sens = 0xFF;
				break;
			case 45: // -



				sens = 0xAA;
				break;
			case 88: // X



				sens = sens & 0xCC;
				break;
			case 89: // Y



				sens = sens & 0x33;
				break;
			case 68: // D : dclenche le calcul intermdiaire



				sens = sens & 0xF0;
				commande = commande + sens;
				sens = 0;

				break;
			case 71: // G : dclenche le calcul intermdiaire



				sens = sens & 0x0F;
				commande = commande + sens;
				sens = 0;
				break;
			default:
				printf("Unknown animal");
				break;
			}

			c = fgetc(sortie);
			if (c == 10) // fin de ligne ==> calcul du mot de commande complet



			{
				fprintf (tempo,"C %d\n", commande);
				commande = 0;
			}

		}

	}
	while (c != EOF);

fprintf (stdout, "**************************************************\n");
	fprintf (stdout, "*                                                *\n");
	fprintf (stdout, "*             CNC pour windows 2000              *\n");
	fprintf (stdout, "*                                                *\n");
	fprintf (stdout, "**************************************************\n");



	fclose (sortie);

	fclose (tempo);
sortie:
	fprintf (stdout, "taper un caractere puis return pour demarrer la decoupe\n");
	i = fscanf (stdin , "%s", chaine);
}




