//****************************************************************************
//
// gnre un fichier .CUT avec dtail des pas  partir des paramtres passs
// par la ligne de commande :
// param 1 = nom du fichier .CUT
// param 2 = dplacement X droit en mm
// param 3 = dplacement Y droit en mm
// param 4 = dplacement X gauche en mm
// param 5 = dplacement Y gauche en mm
// param 6 = nombre de pas par tour des moteurs
// param 7 = dlai en nb IT TIMER entre deux pas moteur
//
//*****************************************************************************

// ATTENTION : ne marche que si les valeurs absolues des dplacement sont gales entre elles
//             ou si le dplacement est nul


#include <conio.h>
#include <stdio.h>
#include <stdlib.h>


#include <math.h>
#include <string.h>


//********************************************************************
// transforme les fichiers .CUT de CNC en un fichier de commandes :
//
//   D dure dcimale   <=== indique un dlai en nb d'IT timers
//   C commande dcimal <=== valeur de la commande  envoyer sur le port //
//
// les commandes sont envoyes avec les dlais suivants :
//    T0 = 1 er ordre bits de direction
//    t1 = 2 ime ordre bits de direction et de commande
//    t2 = mise  zro des bits de commande
// avec :
//     t1 = T0 + epsilon
//     t2 = T0 + 1/2 IT timer
//
//*********************************************************************






void cut2com (FILE *toto)
{






	char chaine[100], tampon[200];
	long i;
	int j;
	int k, c, duree, sens;
	int Bits;    /* 0 <= Bits <= 255 */
	int Dummy;
	unsigned char commande,value,par1, par2, par3, par4;

	FILE *sortie ;
	FILE *cut;
	FILE *tempo;


	cut = fopen(toto,"r");
	if (cut == NULL) {
		printf("\n\n\nERREUR : le fichier %s n'existe pas ...\n\n\n\n",toto);
		goto sortie;
	}

	sortie = fopen( "sortie.txt", "w");

	//filtre des commentaires
	c = fgetc(cut);
	while (c != EOF) {
		if ((c == 'T') | (c == '/') | (c == 'F') | (c == 'N') | (c == 'H'))
		{
			do {
				c = fgetc(cut);
			}
			while (c != '\n');

		}
		else
		    {
			fputc (c, sortie);
		}
		c = fgetc(cut);
	}
	fclose (sortie);


	// generation des ordres CNC pour port par

	tempo = fopen("tempo.txt","w");
	sortie = fopen( "sortie.txt", "r");


	c = fgetc(sortie);
	do {
		ungetc (c,sortie);
		k= fscanf( sortie, "%d" , &duree); // duree de la tempo
		fprintf(tempo,"D %d\n",duree);
		c = fgetc(sortie);
		commande = 0;
		while ((c != 10) && (c != EOF)) {
			if (c == 32) c = fgetc(sortie); // on saute les blancs
			switch (c) { // interprtation des dplacements





			case 43: // +





				sens = 0xFF;
				break;
			case 45: // -





				sens = 0xAA;
				break;
			case 88: // X





				sens = sens & 0xCC;
				break;
			case 89: // Y





				sens = sens & 0x33;
				break;
			case 68: // D : dclenche le calcul intermdiaire





				sens = sens & 0xF0;
				commande = commande + sens;
				sens = 0;

				break;
			case 71: // G : dclenche le calcul intermdiaire





				sens = sens & 0x0F;
				commande = commande + sens;
				sens = 0;
				break;
			default:
				printf("Unknown animal");
				break;
			}

			c = fgetc(sortie);
			if (c == 10) // fin de ligne ==> calcul du mot de commande complet





			{
				fprintf (tempo,"C %d\n", commande);
				commande = 0;
			}

		}

	}
	while (c != EOF);



	fclose (sortie);

	fclose (tempo);
sortie:


	fprintf (stdout, "\ntaper un caractere et return pour lancer le deplacement \n");
	fprintf (stdout, " \n");

	i = fscanf (stdin , "%s", chaine);

	return;
}








void main (int argc,char *argv[])
{

	/*int count;

	for (count=0;count < argc;count++) {
	printf(
	"Argument %d = %s\n",
	count,
	argv[count]);
	}
	*/



	char chaine[100], tampon[200];
	long i;
	int j;
	int k, c, duree, sens;

	unsigned char value;
	int xd,  yd, xg, zg, X, Y, pas_par_mm, tempo, yg,grand;
	char sigxd[5] = "", sigyd[5]="", sigxg[5]="", sigyg[5]="";


	xd = strtod(argv[2],&value);
	yd = strtod(argv[3],&value);
	xg = strtod(argv[4],&value);
	zg = strtod(argv[5],&value);
	pas_par_mm = strtod(argv[6],&value);
	tempo = strtod(argv[7],&value);




	yg = zg; // passer directement par yg sans zg plante le compilo ...
	// calcul des signes
	if (xd != 0)  {
		if (xd >0) strcpy(sigxd, " +XD");
		else strcpy(sigxd, " -XD");
	}
	if (yd != 0)  {
		if (yd >0) strcpy(sigyd, " +YD");
		else strcpy(sigyd, " -YD");
	}
	if (xg != 0)  {
		if (xg >0) strcpy(sigxg, " +XG");
		else strcpy(sigxg, " -XG");
	}
	if (yg != 0)  {
		if (yg >0) strcpy(sigyg, " +YG");
		else strcpy(sigyg, " -YG");
	}


	xd = abs(xd);
	yd = abs(yd);
	xg = abs(xg);
	yg = abs(yg);


	X = (xd >= xg) ? xd : xg;
	Y = (yd >= yg) ? yd : yg;
	grand = (X >= Y ) ? X : Y;

	fprintf (stdout, "**************************************************\n");
	fprintf (stdout, "*                                                *\n");
	fprintf (stdout, "*             CNC pour windows 2000              *\n");
	fprintf (stdout, "*                                                *\n");
	fprintf (stdout, "**************************************************\n");

	fprintf (stdout, "\ndeplacement de %d mm sur les axes %s%s%s%s\n\n",grand, sigxd, sigyd, sigxg, sigyg);



	grand = grand * pas_par_mm;



	FILE *sortie ;


	sortie = fopen(argv[1],"w");

	do {

		fprintf (sortie, "%d%s%s%s%s\n", tempo, sigxd, sigyd, sigxg, sigyg);

	}
	while (--grand);

	fclose (sortie);


	cut2com (argv[1]);
}




